with Ints;
use Ints;

pragma Elaborate_All (Ints);

function Make_Count(MaxL: in Positive) return Int_Vec is
  L1: constant Positive := MaxL+1;
  L2: constant Positive := L1*L1;
  L3: constant Positive := L1*L2;
  KL,KS,KT: Integer;
  I: Integer := 0;
  C: Int_Vec(0 .. L3) := (others => 0);
begin
  KL := 0;
  for L in 0 .. MaxL loop
    KS := KL;
    for S in 0 .. L loop
      KT := KS+S;
      for T in S .. (L+S)/2 loop
        C(KT) := I;
        I := I+(L-T+1)*(T-S+1);
        KT := KT+1;
      end loop;
      KS := KS+L1;
    end loop;
    KL := KL+L2;
  end loop;
  C(L3) := I;
  return C;
end Make_Count;
