
package body Characters is

  function Dig(N: Digs) return Character is
  begin
    if N>9 then return Character'Val(N+55); end if;
    return Character'Val(N+48);
  end Dig;

  function Val(C: Character) return Digs is
    M: constant Natural := Character'Pos(C);
    -- '0' .. '9' --> 48 ..  57
    -- 'A' .. 'Z' --> 65 ..  90
    -- 'a' .. 'z' --> 97 .. 122
  begin
    if M < 48 then raise Constraint_Error with "illegal character"; end if;
    if M <= 57 then return M-48; end if;
    if M < 65 then raise Constraint_Error with "illegal character"; end if;
    if M <= 90 then return M-55; end if;
    if M < 97 then raise Constraint_Error with "illegal character"; end if;
    if M <= 122 then return M-87; end if;
    raise Constraint_Error with "illegal character";
    return 0;
  end Val;

  function Val(C: Character; VMax: Digs) return Digs is
    N: constant Digs := Val(C);
  begin
    if N>VMax then raise Constraint_Error with "illegal character"; end if;
    return N;
  end Val;

end Characters;
