with Globals;

package body Tasks is --- just for compatibility ...

  function Task_Log(H: Attribute_Handle) return File_Access is
  begin
    if H.all.Log=null then return Current_Output; end if;
    return H.all.Log;
  end Task_Log;

  function Task_Log(ID: Task_Id) return File_Access is
    H: constant Attribute_Handle := Reference(ID);
  begin
    if H.all.Log=null then return Current_Output; end if;
    return H.all.Log;
  end Task_Log;

  function Task_Log return File_Access is
    H: constant Attribute_Handle := Reference(Current_Task);
  begin
    if H.all.Log=null then return Current_Output; end if;
    return H.all.Log;
  end Task_Log;

begin

  Globals.Default_Output := Task_Log'Access;

end Tasks;
